#include <iostream>
#include <vector>
#include <utility>
#include <stack>

const short MAX_N = 128;

std::vector<std::pair<int, int> > nbrs[MAX_N];

struct node {
    short to, lenght, edgesCnt;

    void print()
    {
        std::cout << to << ' ' << lenght << ' ' << edgesCnt << '\n';
    }
};

std::stack<node> q;

int main()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    short n, m, k, a, b;
    std::cin >> n >> m >> k >> a >> b;

    for(short i = 0; i < m; ++ i)
    {
        short from, to, lng;
        std::cin >> from >> to >> lng;
        nbrs[from].push_back({to, lng});
    }

    for(short i = 0; i < nbrs[a].size(); ++ i)
    {
        q.push({nbrs[a][i].first, nbrs[a][i].second, 1});
    }

    short min = -1;

    //std::cout << '\n';

    while(!q.empty())
    {
        node curr = q.top();
        q.pop();

        //curr.print();

        if(curr.to == b && curr.edgesCnt == k && (min == -1 || curr.lenght < min))
        {
            min = curr.lenght;
        }else
        {
            for(short i = 0; i < nbrs[curr.to].size(); ++ i)
            {
                if((nbrs[curr.to][i].first != b || (nbrs[curr.to][i].first == b && curr.edgesCnt + 1 == k)) && curr.edgesCnt < k)
                    q.push({nbrs[curr.to][i].first, curr.lenght + nbrs[curr.to][i].second, curr.edgesCnt + 1});
            }
        }
    }

    std::cout << min << '\n';

    return 0;
}
/*
5 6 2 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2

5 6 3 0 4
0 1 1
0 2 4
0 4 2
2 4 6
1 4 7
4 3 2
*/
